Index: palm/trunk/SOURCE/init_3d_model.f90
===================================================================
--- palm/trunk/SOURCE/init_3d_model.f90	(revision 1787)
+++ palm/trunk/SOURCE/init_3d_model.f90	(revision 1788)
@@ -19,5 +19,6 @@
 ! Current revisions:
 ! ------------------
-!
+! Added z0q. 
+! Syntax layout improved.
 !
 ! Former revisions:
@@ -320,72 +321,72 @@
 !
 !-- Allocate arrays
-    ALLOCATE( mean_surface_level_height(0:statistic_regions),               &
-              mean_surface_level_height_l(0:statistic_regions),             &
-              ngp_2dh(0:statistic_regions), ngp_2dh_l(0:statistic_regions), &
-              ngp_3d(0:statistic_regions),                                  &
-              ngp_3d_inner(0:statistic_regions),                            &
-              ngp_3d_inner_l(0:statistic_regions),                          &
-              ngp_3d_inner_tmp(0:statistic_regions),                        &
-              sums_divnew_l(0:statistic_regions),                           &
+    ALLOCATE( mean_surface_level_height(0:statistic_regions),                  &
+              mean_surface_level_height_l(0:statistic_regions),                &
+              ngp_2dh(0:statistic_regions), ngp_2dh_l(0:statistic_regions),    &
+              ngp_3d(0:statistic_regions),                                     &
+              ngp_3d_inner(0:statistic_regions),                               &
+              ngp_3d_inner_l(0:statistic_regions),                             &
+              ngp_3d_inner_tmp(0:statistic_regions),                           &
+              sums_divnew_l(0:statistic_regions),                              &
               sums_divold_l(0:statistic_regions) )
     ALLOCATE( dp_smooth_factor(nzb:nzt), rdf(nzb+1:nzt), rdf_sc(nzb+1:nzt) )
-    ALLOCATE( ngp_2dh_outer(nzb:nzt+1,0:statistic_regions),                 &
-              ngp_2dh_outer_l(nzb:nzt+1,0:statistic_regions),               &
-              ngp_2dh_s_inner(nzb:nzt+1,0:statistic_regions),               &
-              ngp_2dh_s_inner_l(nzb:nzt+1,0:statistic_regions),             &
-              rmask(nysg:nyng,nxlg:nxrg,0:statistic_regions),               &
-              sums(nzb:nzt+1,pr_palm+max_pr_user),                          &
-              sums_l(nzb:nzt+1,pr_palm+max_pr_user,0:threads_per_task-1),   &
-              sums_l_l(nzb:nzt+1,0:statistic_regions,0:threads_per_task-1), &
-              sums_up_fraction_l(10,3,0:statistic_regions),                 &
-              sums_wsts_bc_l(nzb:nzt+1,0:statistic_regions),                &
+    ALLOCATE( ngp_2dh_outer(nzb:nzt+1,0:statistic_regions),                    &
+              ngp_2dh_outer_l(nzb:nzt+1,0:statistic_regions),                  &
+              ngp_2dh_s_inner(nzb:nzt+1,0:statistic_regions),                  &
+              ngp_2dh_s_inner_l(nzb:nzt+1,0:statistic_regions),                &
+              rmask(nysg:nyng,nxlg:nxrg,0:statistic_regions),                  &
+              sums(nzb:nzt+1,pr_palm+max_pr_user),                             &
+              sums_l(nzb:nzt+1,pr_palm+max_pr_user,0:threads_per_task-1),      &
+              sums_l_l(nzb:nzt+1,0:statistic_regions,0:threads_per_task-1),    &
+              sums_up_fraction_l(10,3,0:statistic_regions),                    &
+              sums_wsts_bc_l(nzb:nzt+1,0:statistic_regions),                   &
               ts_value(dots_max,0:statistic_regions) )
     ALLOCATE( ptdf_x(nxlg:nxrg), ptdf_y(nysg:nyng) )
 
-    ALLOCATE( ol(nysg:nyng,nxlg:nxrg), shf(nysg:nyng,nxlg:nxrg),      &
-              ts(nysg:nyng,nxlg:nxrg), tswst(nysg:nyng,nxlg:nxrg),    &
-              us(nysg:nyng,nxlg:nxrg), usws(nysg:nyng,nxlg:nxrg),     &
-              uswst(nysg:nyng,nxlg:nxrg), vsws(nysg:nyng,nxlg:nxrg),  &
-              vswst(nysg:nyng,nxlg:nxrg), z0(nysg:nyng,nxlg:nxrg),    &
-              z0h(nysg:nyng,nxlg:nxrg) )
-
-    ALLOCATE( d(nzb+1:nzt,nys:nyn,nxl:nxr),         &
-              kh(nzb:nzt+1,nysg:nyng,nxlg:nxrg),    &
-              km(nzb:nzt+1,nysg:nyng,nxlg:nxrg),    &
-              p(nzb:nzt+1,nysg:nyng,nxlg:nxrg),     &
+    ALLOCATE( ol(nysg:nyng,nxlg:nxrg), shf(nysg:nyng,nxlg:nxrg),               &
+              ts(nysg:nyng,nxlg:nxrg), tswst(nysg:nyng,nxlg:nxrg),             &
+              us(nysg:nyng,nxlg:nxrg), usws(nysg:nyng,nxlg:nxrg),              &
+              uswst(nysg:nyng,nxlg:nxrg), vsws(nysg:nyng,nxlg:nxrg),           &
+              vswst(nysg:nyng,nxlg:nxrg), z0(nysg:nyng,nxlg:nxrg),             &
+              z0h(nysg:nyng,nxlg:nxrg), z0q(nysg:nyng,nxlg:nxrg) )
+
+    ALLOCATE( d(nzb+1:nzt,nys:nyn,nxl:nxr),                                    &
+              kh(nzb:nzt+1,nysg:nyng,nxlg:nxrg),                               &
+              km(nzb:nzt+1,nysg:nyng,nxlg:nxrg),                               &
+              p(nzb:nzt+1,nysg:nyng,nxlg:nxrg),                                &
               tend(nzb:nzt+1,nysg:nyng,nxlg:nxrg) )
 
 #if defined( __nopointer )
-    ALLOCATE( e(nzb:nzt+1,nysg:nyng,nxlg:nxrg),     &
-              e_p(nzb:nzt+1,nysg:nyng,nxlg:nxrg),   &
-              pt(nzb:nzt+1,nysg:nyng,nxlg:nxrg),    &
-              pt_p(nzb:nzt+1,nysg:nyng,nxlg:nxrg),  &
-              u(nzb:nzt+1,nysg:nyng,nxlg:nxrg),     &
-              u_p(nzb:nzt+1,nysg:nyng,nxlg:nxrg),   &
-              v(nzb:nzt+1,nysg:nyng,nxlg:nxrg),     &
-              v_p(nzb:nzt+1,nysg:nyng,nxlg:nxrg),   &
-              w(nzb:nzt+1,nysg:nyng,nxlg:nxrg),     &
-              w_p(nzb:nzt+1,nysg:nyng,nxlg:nxrg),   &
-              te_m(nzb:nzt+1,nysg:nyng,nxlg:nxrg),  &
-              tpt_m(nzb:nzt+1,nysg:nyng,nxlg:nxrg), &
-              tu_m(nzb:nzt+1,nysg:nyng,nxlg:nxrg),  &
-              tv_m(nzb:nzt+1,nysg:nyng,nxlg:nxrg),  &
+    ALLOCATE( e(nzb:nzt+1,nysg:nyng,nxlg:nxrg),                                &
+              e_p(nzb:nzt+1,nysg:nyng,nxlg:nxrg),                              &
+              pt(nzb:nzt+1,nysg:nyng,nxlg:nxrg),                               &
+              pt_p(nzb:nzt+1,nysg:nyng,nxlg:nxrg),                             &
+              u(nzb:nzt+1,nysg:nyng,nxlg:nxrg),                                &
+              u_p(nzb:nzt+1,nysg:nyng,nxlg:nxrg),                              &
+              v(nzb:nzt+1,nysg:nyng,nxlg:nxrg),                                &
+              v_p(nzb:nzt+1,nysg:nyng,nxlg:nxrg),                              &
+              w(nzb:nzt+1,nysg:nyng,nxlg:nxrg),                                &
+              w_p(nzb:nzt+1,nysg:nyng,nxlg:nxrg),                              &
+              te_m(nzb:nzt+1,nysg:nyng,nxlg:nxrg),                             &
+              tpt_m(nzb:nzt+1,nysg:nyng,nxlg:nxrg),                            &
+              tu_m(nzb:nzt+1,nysg:nyng,nxlg:nxrg),                             &
+              tv_m(nzb:nzt+1,nysg:nyng,nxlg:nxrg),                             &
               tw_m(nzb:nzt+1,nysg:nyng,nxlg:nxrg) )
 #else
-    ALLOCATE( e_1(nzb:nzt+1,nysg:nyng,nxlg:nxrg),   &
-              e_2(nzb:nzt+1,nysg:nyng,nxlg:nxrg),   &
-              e_3(nzb:nzt+1,nysg:nyng,nxlg:nxrg),   &
-              pt_1(nzb:nzt+1,nysg:nyng,nxlg:nxrg),  &
-              pt_3(nzb:nzt+1,nysg:nyng,nxlg:nxrg),  &
-              u_1(nzb:nzt+1,nysg:nyng,nxlg:nxrg),   &
-              u_2(nzb:nzt+1,nysg:nyng,nxlg:nxrg),   &
-              u_3(nzb:nzt+1,nysg:nyng,nxlg:nxrg),   &
-              v_1(nzb:nzt+1,nysg:nyng,nxlg:nxrg),   &
-              v_2(nzb:nzt+1,nysg:nyng,nxlg:nxrg),   &
-              v_3(nzb:nzt+1,nysg:nyng,nxlg:nxrg),   &
-              w_1(nzb:nzt+1,nysg:nyng,nxlg:nxrg),   &
-              w_2(nzb:nzt+1,nysg:nyng,nxlg:nxrg),   &
+    ALLOCATE( e_1(nzb:nzt+1,nysg:nyng,nxlg:nxrg),                              &
+              e_2(nzb:nzt+1,nysg:nyng,nxlg:nxrg),                              &
+              e_3(nzb:nzt+1,nysg:nyng,nxlg:nxrg),                              &
+              pt_1(nzb:nzt+1,nysg:nyng,nxlg:nxrg),                             &
+              pt_3(nzb:nzt+1,nysg:nyng,nxlg:nxrg),                             &
+              u_1(nzb:nzt+1,nysg:nyng,nxlg:nxrg),                              &
+              u_2(nzb:nzt+1,nysg:nyng,nxlg:nxrg),                              &
+              u_3(nzb:nzt+1,nysg:nyng,nxlg:nxrg),                              &
+              v_1(nzb:nzt+1,nysg:nyng,nxlg:nxrg),                              &
+              v_2(nzb:nzt+1,nysg:nyng,nxlg:nxrg),                              &
+              v_3(nzb:nzt+1,nysg:nyng,nxlg:nxrg),                              &
+              w_1(nzb:nzt+1,nysg:nyng,nxlg:nxrg),                              &
+              w_2(nzb:nzt+1,nysg:nyng,nxlg:nxrg),                              &
               w_3(nzb:nzt+1,nysg:nyng,nxlg:nxrg) )
-    IF ( .NOT. neutral )  THEN
+    IF (  .NOT.  neutral )  THEN
        ALLOCATE( pt_2(nzb:nzt+1,nysg:nyng,nxlg:nxrg) )
     ENDIF
@@ -412,9 +413,9 @@
     ENDIF
 
-    IF ( humidity  .OR.  passive_scalar ) THEN
+    IF ( humidity  .OR.  passive_scalar )  THEN
 !
 !--    2D-humidity/scalar arrays
-       ALLOCATE ( qs(nysg:nyng,nxlg:nxrg),   &
-                  qsws(nysg:nyng,nxlg:nxrg), &
+       ALLOCATE ( qs(nysg:nyng,nxlg:nxrg),                                     &
+                  qsws(nysg:nyng,nxlg:nxrg),                                   &
                   qswst(nysg:nyng,nxlg:nxrg) )
 
@@ -422,10 +423,10 @@
 !--    3D-humidity/scalar arrays
 #if defined( __nopointer )
-       ALLOCATE( q(nzb:nzt+1,nysg:nyng,nxlg:nxrg),   &
-                 q_p(nzb:nzt+1,nysg:nyng,nxlg:nxrg), &
+       ALLOCATE( q(nzb:nzt+1,nysg:nyng,nxlg:nxrg),                             &
+                 q_p(nzb:nzt+1,nysg:nyng,nxlg:nxrg),                           &
                  tq_m(nzb:nzt+1,nysg:nyng,nxlg:nxrg) )
 #else
-       ALLOCATE( q_1(nzb:nzt+1,nysg:nyng,nxlg:nxrg), &
-                 q_2(nzb:nzt+1,nysg:nyng,nxlg:nxrg), &
+       ALLOCATE( q_1(nzb:nzt+1,nysg:nyng,nxlg:nxrg),                           &
+                 q_2(nzb:nzt+1,nysg:nyng,nxlg:nxrg),                           &
                  q_3(nzb:nzt+1,nysg:nyng,nxlg:nxrg) )
 #endif
@@ -440,5 +441,5 @@
 #endif
 
-          IF ( cloud_physics ) THEN
+          IF ( cloud_physics )  THEN
 
 !
@@ -451,5 +452,5 @@
 !
 !--          Precipitation amount and rate (only needed if output is switched)
-             ALLOCATE( precipitation_amount(nysg:nyng,nxlg:nxrg), &
+             ALLOCATE( precipitation_amount(nysg:nyng,nxlg:nxrg),              &
                        precipitation_rate(nysg:nyng,nxlg:nxrg) )
 
@@ -457,5 +458,5 @@
 !
 !--             1D-arrays 
-                ALLOCATE ( nc_1d(nzb:nzt+1), pt_1d(nzb:nzt+1), &
+                ALLOCATE ( nc_1d(nzb:nzt+1), pt_1d(nzb:nzt+1),                 &
                            q_1d(nzb:nzt+1), qc_1d(nzb:nzt+1) ) 
 !
@@ -474,25 +475,25 @@
 !
 !--                2D-rain water content and rain drop concentration arrays
-                   ALLOCATE ( qrs(nysg:nyng,nxlg:nxrg),                 &
-                              qrsws(nysg:nyng,nxlg:nxrg),               &
-                              qrswst(nysg:nyng,nxlg:nxrg),              &
-                              nrs(nysg:nyng,nxlg:nxrg),                 &
-                              nrsws(nysg:nyng,nxlg:nxrg),               &
+                   ALLOCATE ( qrs(nysg:nyng,nxlg:nxrg),                        &
+                              qrsws(nysg:nyng,nxlg:nxrg),                      &
+                              qrswst(nysg:nyng,nxlg:nxrg),                     &
+                              nrs(nysg:nyng,nxlg:nxrg),                        &
+                              nrsws(nysg:nyng,nxlg:nxrg),                      &
                               nrswst(nysg:nyng,nxlg:nxrg) )
 !
 !--                3D-rain water content, rain drop concentration arrays
 #if defined( __nopointer )
-                   ALLOCATE( nr(nzb:nzt+1,nysg:nyng,nxlg:nxrg),         &
-                             nr_p(nzb:nzt+1,nysg:nyng,nxlg:nxrg),       &
-                             qr(nzb:nzt+1,nysg:nyng,nxlg:nxrg),         &
-                             qr_p(nzb:nzt+1,nysg:nyng,nxlg:nxrg),       &
-                             tnr_m(nzb:nzt+1,nysg:nyng,nxlg:nxrg),      &
+                   ALLOCATE( nr(nzb:nzt+1,nysg:nyng,nxlg:nxrg),                &
+                             nr_p(nzb:nzt+1,nysg:nyng,nxlg:nxrg),              &
+                             qr(nzb:nzt+1,nysg:nyng,nxlg:nxrg),                &
+                             qr_p(nzb:nzt+1,nysg:nyng,nxlg:nxrg),              &
+                             tnr_m(nzb:nzt+1,nysg:nyng,nxlg:nxrg),             &
                              tqr_m(nzb:nzt+1,nysg:nyng,nxlg:nxrg) )
 #else
-                   ALLOCATE( nr_1(nzb:nzt+1,nysg:nyng,nxlg:nxrg),       &
-                             nr_2(nzb:nzt+1,nysg:nyng,nxlg:nxrg),       &
-                             nr_3(nzb:nzt+1,nysg:nyng,nxlg:nxrg),       &
-                             qr_1(nzb:nzt+1,nysg:nyng,nxlg:nxrg),       &
-                             qr_2(nzb:nzt+1,nysg:nyng,nxlg:nxrg),       &
+                   ALLOCATE( nr_1(nzb:nzt+1,nysg:nyng,nxlg:nxrg),              &
+                             nr_2(nzb:nzt+1,nysg:nyng,nxlg:nxrg),              &
+                             nr_3(nzb:nzt+1,nysg:nyng,nxlg:nxrg),              &
+                             qr_1(nzb:nzt+1,nysg:nyng,nxlg:nxrg),              &
+                             qr_2(nzb:nzt+1,nysg:nyng,nxlg:nxrg),              &
                              qr_3(nzb:nzt+1,nysg:nyng,nxlg:nxrg) )
 #endif
@@ -509,13 +510,13 @@
 !--          Liquid water content, change in liquid water content
 #if defined( __nopointer )
-             ALLOCATE ( ql(nzb:nzt+1,nysg:nyng,nxlg:nxrg), &
+             ALLOCATE ( ql(nzb:nzt+1,nysg:nyng,nxlg:nxrg),                     &
                         ql_c(nzb:nzt+1,nysg:nyng,nxlg:nxrg) )
 #else
-             ALLOCATE ( ql_1(nzb:nzt+1,nysg:nyng,nxlg:nxrg), &
+             ALLOCATE ( ql_1(nzb:nzt+1,nysg:nyng,nxlg:nxrg),                   &
                         ql_2(nzb:nzt+1,nysg:nyng,nxlg:nxrg) )
 #endif
 !
 !--          Real volume of particles (with weighting), volume of particles
-             ALLOCATE ( ql_v(nzb:nzt+1,nysg:nyng,nxlg:nxrg), &
+             ALLOCATE ( ql_v(nzb:nzt+1,nysg:nyng,nxlg:nxrg),                   &
                         ql_vp(nzb:nzt+1,nysg:nyng,nxlg:nxrg) )
           ENDIF
@@ -526,17 +527,17 @@
 
     IF ( ocean )  THEN
-       ALLOCATE( saswsb(nysg:nyng,nxlg:nxrg), &
+       ALLOCATE( saswsb(nysg:nyng,nxlg:nxrg),                                  &
                  saswst(nysg:nyng,nxlg:nxrg) )
 #if defined( __nopointer )
-       ALLOCATE( prho(nzb:nzt+1,nysg:nyng,nxlg:nxrg),   &
-                 rho(nzb:nzt+1,nysg:nyng,nxlg:nxrg),    &
-                 sa(nzb:nzt+1,nysg:nyng,nxlg:nxrg),     &
-                 sa_p(nzb:nzt+1,nysg:nyng,nxlg:nxrg),   &
+       ALLOCATE( prho(nzb:nzt+1,nysg:nyng,nxlg:nxrg),                          &
+                 rho(nzb:nzt+1,nysg:nyng,nxlg:nxrg),                           &
+                 sa(nzb:nzt+1,nysg:nyng,nxlg:nxrg),                            &
+                 sa_p(nzb:nzt+1,nysg:nyng,nxlg:nxrg),                          &
                  tsa_m(nzb:nzt+1,nysg:nyng,nxlg:nxrg) )
 #else
-       ALLOCATE( prho_1(nzb:nzt+1,nysg:nyng,nxlg:nxrg), &
-                 rho_1(nzb:nzt+1,nysg:nyng,nxlg:nxrg),  &
-                 sa_1(nzb:nzt+1,nysg:nyng,nxlg:nxrg),   &
-                 sa_2(nzb:nzt+1,nysg:nyng,nxlg:nxrg),   &
+       ALLOCATE( prho_1(nzb:nzt+1,nysg:nyng,nxlg:nxrg),                        &
+                 rho_1(nzb:nzt+1,nysg:nyng,nxlg:nxrg),                         &
+                 sa_1(nzb:nzt+1,nysg:nyng,nxlg:nxrg),                          &
+                 sa_2(nzb:nzt+1,nysg:nyng,nxlg:nxrg),                          &
                  sa_3(nzb:nzt+1,nysg:nyng,nxlg:nxrg) )
        prho => prho_1
@@ -553,5 +554,5 @@
 !-- 3D-array for storing the dissipation, needed for calculating the sgs
 !-- particle velocities
-    IF ( use_sgs_for_particles  .OR.  wang_kernel  .OR.  turbulence  .OR.  &
+    IF ( use_sgs_for_particles  .OR.  wang_kernel  .OR.  turbulence  .OR.      &
          num_acc_per_node > 0 )  THEN
        ALLOCATE( diss(nzb:nzt+1,nysg:nyng,nxlg:nxrg) )
@@ -559,5 +560,5 @@
 
     IF ( dt_dosp /= 9999999.9_wp )  THEN
-       ALLOCATE( spectrum_x( 1:nx/2, 1:10, 1:10 ), &
+       ALLOCATE( spectrum_x( 1:nx/2, 1:10, 1:10 ),                             &
                  spectrum_y( 1:ny/2, 1:10, 1:10 ) )
        spectrum_x = 0.0_wp
@@ -595,29 +596,29 @@
 !-- are needed for radiation boundary conditions
     IF ( outflow_l )  THEN
-       ALLOCATE( u_m_l(nzb:nzt+1,nysg:nyng,1:2), &
-                 v_m_l(nzb:nzt+1,nysg:nyng,0:1), &
+       ALLOCATE( u_m_l(nzb:nzt+1,nysg:nyng,1:2),                               &
+                 v_m_l(nzb:nzt+1,nysg:nyng,0:1),                               &
                  w_m_l(nzb:nzt+1,nysg:nyng,0:1) )
     ENDIF
     IF ( outflow_r )  THEN
-       ALLOCATE( u_m_r(nzb:nzt+1,nysg:nyng,nx-1:nx), &
-                 v_m_r(nzb:nzt+1,nysg:nyng,nx-1:nx), &
+       ALLOCATE( u_m_r(nzb:nzt+1,nysg:nyng,nx-1:nx),                           &
+                 v_m_r(nzb:nzt+1,nysg:nyng,nx-1:nx),                           &
                  w_m_r(nzb:nzt+1,nysg:nyng,nx-1:nx) )
     ENDIF
     IF ( outflow_l  .OR.  outflow_r )  THEN
-       ALLOCATE( c_u(nzb:nzt+1,nysg:nyng), c_v(nzb:nzt+1,nysg:nyng), &
+       ALLOCATE( c_u(nzb:nzt+1,nysg:nyng), c_v(nzb:nzt+1,nysg:nyng),           &
                  c_w(nzb:nzt+1,nysg:nyng) )
     ENDIF
     IF ( outflow_s )  THEN
-       ALLOCATE( u_m_s(nzb:nzt+1,0:1,nxlg:nxrg), &
-                 v_m_s(nzb:nzt+1,1:2,nxlg:nxrg), &
+       ALLOCATE( u_m_s(nzb:nzt+1,0:1,nxlg:nxrg),                               &
+                 v_m_s(nzb:nzt+1,1:2,nxlg:nxrg),                               &
                  w_m_s(nzb:nzt+1,0:1,nxlg:nxrg) )
     ENDIF
     IF ( outflow_n )  THEN
-       ALLOCATE( u_m_n(nzb:nzt+1,ny-1:ny,nxlg:nxrg), &
-                 v_m_n(nzb:nzt+1,ny-1:ny,nxlg:nxrg), &
+       ALLOCATE( u_m_n(nzb:nzt+1,ny-1:ny,nxlg:nxrg),                           &
+                 v_m_n(nzb:nzt+1,ny-1:ny,nxlg:nxrg),                           &
                  w_m_n(nzb:nzt+1,ny-1:ny,nxlg:nxrg) )
     ENDIF
     IF ( outflow_s  .OR.  outflow_n )  THEN
-       ALLOCATE( c_u(nzb:nzt+1,nxlg:nxrg), c_v(nzb:nzt+1,nxlg:nxrg), &
+       ALLOCATE( c_u(nzb:nzt+1,nxlg:nxrg), c_v(nzb:nzt+1,nxlg:nxrg),           &
                  c_w(nzb:nzt+1,nxlg:nxrg) )
     ENDIF
@@ -682,5 +683,5 @@
 !--        pres may need to be called  outside the RK-substeps. Antti will
 !--        check if this is really required.
-    ALLOCATE( weight_substep(1:intermediate_timestep_count_max), &
+    ALLOCATE( weight_substep(1:intermediate_timestep_count_max),               &
               weight_pres(0:intermediate_timestep_count_max) )
     weight_substep = 1.0_wp
@@ -691,5 +692,5 @@
 !
 !-- Initialize model variables
-    IF ( TRIM( initializing_actions ) /= 'read_restart_data'  .AND.  &
+    IF ( TRIM( initializing_actions ) /= 'read_restart_data'  .AND.            &
          TRIM( initializing_actions ) /= 'cyclic_fill' )  THEN
 !
@@ -819,5 +820,5 @@
           CALL location_message( 'finished', .TRUE. )
 
-       ELSEIF ( INDEX(initializing_actions, 'set_constant_profiles') /= 0 ) &
+       ELSEIF ( INDEX(initializing_actions, 'set_constant_profiles') /= 0 )    &
        THEN
 
@@ -825,5 +826,5 @@
 !
 !--       Overwrite initial profiles in case of nudging
-          IF ( nudging ) THEN
+          IF ( nudging )  THEN
              pt_init = ptnudge(:,1)
              u_init  = unudge(:,1)
@@ -833,5 +834,5 @@
              ENDIF
 
-             WRITE( message_string, * ) 'Initial profiles of u, v and ', &
+             WRITE( message_string, * ) 'Initial profiles of u, v and ',       &
                  'scalars from NUDGING_DATA are used.'
              CALL message( 'init_3d_model', 'PA0370', 0, 0, 0, 6, 0 )
@@ -936,5 +937,5 @@
           CALL location_message( 'finished', .TRUE. )
 
-       ELSEIF ( INDEX(initializing_actions, 'by_user') /= 0 ) &
+       ELSEIF ( INDEX(initializing_actions, 'by_user') /= 0 )                  &
        THEN
 
@@ -1018,5 +1019,6 @@
           DO j=0,ny
              DO i=0,nx
-                id_random_array(j,i) = random_dummy + 1E6 * ( ensemble_member_nr - 1000 )
+                id_random_array(j,i) = random_dummy + 1E6                      &
+                                       * ( ensemble_member_nr - 1000 )
                 random_dummy = random_dummy + 1
              END DO
@@ -1047,5 +1049,5 @@
 !
 !--             Initialize shf with data from external file LSF_DATA
-                IF ( large_scale_forcing .AND. lsf_surf ) THEN
+                IF ( large_scale_forcing .AND. lsf_surf )  THEN
                    CALL ls_forcing_surf ( simulated_time )
                 ENDIF
@@ -1068,5 +1070,5 @@
 !--       Determine the near-surface water flux
           IF ( humidity  .OR.  passive_scalar )  THEN
-             IF ( cloud_physics  .AND.  icloud_scheme == 0  .AND.  &
+             IF ( cloud_physics  .AND.  icloud_scheme == 0  .AND.              &
                   precipitation )  THEN
                 qrsws = 0.0_wp
@@ -1106,5 +1108,5 @@
              IF ( humidity  .OR.  passive_scalar )  THEN
                 qswst = 0.0_wp
-                IF ( cloud_physics  .AND.  icloud_scheme == 0  .AND.  &
+                IF ( cloud_physics  .AND.  icloud_scheme == 0  .AND.           &
                      precipitation ) THEN
                    nrswst = 0.0_wp
@@ -1133,4 +1135,5 @@
           z0 = roughness_length
           z0h = z0h_factor * z0
+          z0q = z0h_factor * z0
 
           IF ( .NOT. constant_heatflux )  THEN 
@@ -1145,6 +1148,6 @@
 
           IF ( humidity  .OR.  passive_scalar )  THEN
-             IF ( .NOT. constant_waterflux )  qsws   = 0.0_wp
-             IF ( cloud_physics  .AND.  icloud_scheme == 0  .AND.  &
+             IF (  .NOT.  constant_waterflux )  qsws   = 0.0_wp
+             IF ( cloud_physics  .AND.  icloud_scheme == 0  .AND.              &
                   precipitation )  THEN
                 qrsws = 0.0_wp
@@ -1159,5 +1162,5 @@
 !--    the reference state will be set (overwritten) in init_ocean)
        IF ( use_single_reference_value )  THEN
-          IF ( .NOT. humidity )  THEN
+          IF (  .NOT.  humidity )  THEN
              ref_state(:) = pt_reference
           ELSE
@@ -1165,5 +1168,5 @@
           ENDIF
        ELSE
-          IF ( .NOT. humidity )  THEN
+          IF (  .NOT.  humidity )  THEN
              ref_state(:) = pt_init(:)
           ELSE
@@ -1216,5 +1219,5 @@
 !--    If required, change the surface humidity/scalar at the start of the 3D
 !--    run
-       IF ( ( humidity .OR. passive_scalar ) .AND. &
+       IF ( ( humidity .OR. passive_scalar ) .AND.                             &
             q_surface_initial_change /= 0.0_wp )  THEN
           q(nzb,:,:) = q(nzb,:,:) + q_surface_initial_change
@@ -1229,5 +1232,5 @@
           tq_m = 0.0_wp
           q_p = q
-          IF ( cloud_physics  .AND.  icloud_scheme == 0  .AND.  &
+          IF ( cloud_physics  .AND.  icloud_scheme == 0  .AND.                 &
                precipitation )  THEN
              tqr_m = 0.0_wp
@@ -1245,6 +1248,6 @@
        CALL location_message( 'finished', .TRUE. )
 
-    ELSEIF ( TRIM( initializing_actions ) == 'read_restart_data'  .OR.    &
-         TRIM( initializing_actions ) == 'cyclic_fill' )  &
+    ELSEIF ( TRIM( initializing_actions ) == 'read_restart_data'  .OR.         &
+         TRIM( initializing_actions ) == 'cyclic_fill' )                       &
     THEN
 
@@ -1282,5 +1285,5 @@
 !
 !--    Initialization of the turbulence recycling method
-       IF ( TRIM( initializing_actions ) == 'cyclic_fill'  .AND.  &
+       IF ( TRIM( initializing_actions ) == 'cyclic_fill'  .AND.               &
             turbulent_inflow )  THEN
 !
@@ -1346,6 +1349,6 @@
                 inflow_damping_height = hom_sum(nzb+6,pr_palm,0)
              ELSE
-                WRITE( message_string, * ) 'inflow_damping_height must be ',&
-                     'explicitly specified because&the inversion height ', &
+                WRITE( message_string, * ) 'inflow_damping_height must be ',   &
+                     'explicitly specified because&the inversion height ',     &
                      'calculated by the prerun is zero.'
                 CALL message( 'init_3d_model', 'PA0318', 1, 2, 0, 6, 0 )
@@ -1382,5 +1385,5 @@
 !
 !--    Inside buildings set velocities and TKE back to zero
-       IF ( TRIM( initializing_actions ) == 'cyclic_fill' .AND.  &
+       IF ( TRIM( initializing_actions ) == 'cyclic_fill' .AND.                &
             topography /= 'flat' )  THEN
 !
@@ -1415,5 +1418,5 @@
        IF ( humidity  .OR.  passive_scalar )  THEN
           q_p = q
-          IF ( cloud_physics  .AND.  icloud_scheme == 0  .AND.  &
+          IF ( cloud_physics  .AND.  icloud_scheme == 0  .AND.                 &
                precipitation )  THEN
              qr_p = qr
@@ -1430,5 +1433,5 @@
        IF ( humidity  .OR.  passive_scalar )  THEN
           tq_m = 0.0_wp
-          IF ( cloud_physics  .AND.  icloud_scheme == 0  .AND.  &
+          IF ( cloud_physics  .AND.  icloud_scheme == 0  .AND.                 &
                precipitation )  THEN
              tqr_m = 0.0_wp
@@ -1486,5 +1489,5 @@
              DO  j = nys, nyn
                 DO  k = nzb_2d(j,nx)+1, nzt
-                   volume_flow_initial_l(1) = volume_flow_initial_l(1) + &
+                   volume_flow_initial_l(1) = volume_flow_initial_l(1) +       &
                                               u_init(k) * dzw(k)
                    volume_flow_area_l(1)    = volume_flow_area_l(1) + dzw(k)
@@ -1522,5 +1525,5 @@
              DO  j = nys, nyn
                 DO  k = nzb_2d(j,nx)+1, nzt
-                   volume_flow_initial_l(1) = volume_flow_initial_l(1) + &
+                   volume_flow_initial_l(1) = volume_flow_initial_l(1) +       &
                                               hom_sum(k,1,0) * dzw(k)
                    volume_flow_area_l(1)    = volume_flow_area_l(1) + dzw(k)
@@ -1532,5 +1535,5 @@
              DO  i = nxl, nxr
                 DO  k = nzb_2d(ny,i)+1, nzt  
-                   volume_flow_initial_l(2) = volume_flow_initial_l(2) + &
+                   volume_flow_initial_l(2) = volume_flow_initial_l(2) +       &
                                               hom_sum(k,2,0) * dzw(k)
                    volume_flow_area_l(2)    = volume_flow_area_l(2) + dzw(k)
@@ -1568,5 +1571,5 @@
              DO  i = nxl, nxr
                 DO  k = nzb_2d(ny,i)+1, nzt  
-                   volume_flow_initial_l(2) = volume_flow_initial_l(2) + &
+                   volume_flow_initial_l(2) = volume_flow_initial_l(2) +       &
                                               v(k,ny,i) * dzw(k)
                    volume_flow_area_l(2)    = volume_flow_area_l(2) + dzw(k)
@@ -1605,6 +1608,6 @@
 !-- Impose random perturbation on the horizontal velocity field and then
 !-- remove the divergences from the velocity field at the initial stage
-    IF ( create_disturbances  .AND.  disturbance_energy_limit /= 0.0_wp  .AND.&
-         TRIM( initializing_actions ) /= 'read_restart_data'  .AND.  &
+    IF ( create_disturbances  .AND.  disturbance_energy_limit /= 0.0_wp  .AND. &
+         TRIM( initializing_actions ) /= 'read_restart_data'  .AND.            &
          TRIM( initializing_actions ) /= 'cyclic_fill' )  THEN
 
@@ -1718,10 +1721,10 @@
     rdf_sc = 0.0_wp
     IF ( rayleigh_damping_factor /= 0.0_wp )  THEN
-       IF ( .NOT. ocean )  THEN
+       IF (  .NOT.  ocean )  THEN
           DO  k = nzb+1, nzt
              IF ( zu(k) >= rayleigh_damping_height )  THEN
-                rdf(k) = rayleigh_damping_factor * &
+                rdf(k) = rayleigh_damping_factor *                             &
                       ( SIN( pi * 0.5_wp * ( zu(k) - rayleigh_damping_height ) &
-                                         / ( zu(nzt) - rayleigh_damping_height ) )&
+                             / ( zu(nzt) - rayleigh_damping_height ) )         &
                       )**2
              ENDIF
@@ -1730,7 +1733,7 @@
           DO  k = nzt, nzb+1, -1
              IF ( zu(k) <= rayleigh_damping_height )  THEN
-                rdf(k) = rayleigh_damping_factor * &
+                rdf(k) = rayleigh_damping_factor *                             &
                       ( SIN( pi * 0.5_wp * ( rayleigh_damping_height - zu(k) ) &
-                                         / ( rayleigh_damping_height - zu(nzb+1)))&
+                             / ( rayleigh_damping_height - zu(nzb+1) ) )       &
                       )**2
              ENDIF
@@ -1774,5 +1777,5 @@
              ptdf_x(i) = pt_damping_factor * ( SIN( pi * 0.5_wp *              &
                             REAL( pt_damping_width - i * dx, KIND=wp ) / (     &
-                            REAL( pt_damping_width, KIND=wp )            ) ) )**2 
+                            REAL( pt_damping_width, KIND=wp ) ) ) )**2 
           ENDIF
        ENDDO
@@ -1831,6 +1834,6 @@
 
     IF ( dots_num > dots_max )  THEN
-       WRITE( message_string, * ) 'number of time series quantities exceeds', &
-                                  ' its maximum of dots_max = ', dots_max,    &
+       WRITE( message_string, * ) 'number of time series quantities exceeds',  &
+                                  ' its maximum of dots_max = ', dots_max,     &
                                   ' &Please increase dots_max in modules.f90.'
        CALL message( 'init_3d_model', 'PA0194', 1, 2, 0, 6, 0 )    
@@ -1869,6 +1872,6 @@
 !--             All xy-grid points
                 ngp_2dh_l(sr) = ngp_2dh_l(sr) + 1
-                mean_surface_level_height_l(sr) = mean_surface_level_height_l(sr) + &
-                                                  zw(nzb_s_inner(j,i))
+                mean_surface_level_height_l(sr) = mean_surface_level_height_l(sr) &
+                                                  + zw(nzb_s_inner(j,i))
 !
 !--             xy-grid points above topography
@@ -1881,6 +1884,6 @@
 !
 !--             All grid points of the total domain above topography
-                ngp_3d_inner_l(sr) = ngp_3d_inner_l(sr) + &
-                                     ( nz - nzb_s_inner(j,i) + 2 )
+                ngp_3d_inner_l(sr) = ngp_3d_inner_l(sr)                        &
+                                     + ( nz - nzb_s_inner(j,i) + 2 )
              ENDIF
           ENDDO
